diff --git a/compiler/typecheck/TcType.lhs b/compiler/typecheck/TcType.lhs
index 8e5bac4..2cc3324 100644
--- a/compiler/typecheck/TcType.lhs
+++ b/compiler/typecheck/TcType.lhs
@@ -7,20 +7,14 @@
 This module provides the Type interface for front-end parts of the 
 compiler.  These parts 
 
-	* treat "source types" as opaque: 
-		newtypes, and predicates are meaningful. 
-	* look through usage types
+        * treat "source types" as opaque: 
+                newtypes, and predicates are meaningful. 
+        * look through usage types
 
 The "tc" prefix is for "TypeChecker", because the type checker
 is the principal client.
 
 \begin{code}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module TcType (
   --------------------------------
@@ -102,7 +96,7 @@ module TcType (
   isFFILabelTy,        -- :: Type -> Bool
   isFFIDotnetTy,       -- :: DynFlags -> Type -> Bool
   isFFIDotnetObjTy,    -- :: Type -> Bool
-  isFFITy,	       -- :: Type -> Bool
+  isFFITy,             -- :: Type -> Bool
   isFunPtrTy,          -- :: Type -> Bool
   tcSplitIOType_maybe, -- :: Type -> Maybe Type  
 
@@ -129,7 +123,7 @@ module TcType (
   mkEqPred, 
 
   -- Type substitutions
-  TvSubst(..), 	-- Representation visible to a few friends
+  TvSubst(..),  -- Representation visible to a few friends
   TvSubstEnv, emptyTvSubst, 
   mkOpenTvSubst, zipOpenTvSubst, zipTopTvSubst, 
   mkTopTvSubst, notElemTvSubst, unionTvSubst,
@@ -138,8 +132,8 @@ module TcType (
   extendTvSubstList, isInScope, mkTvSubst, zipTyEnv,
   Type.substTy, substTys, substTyWith, substTheta, substTyVar, substTyVars, 
 
-  isUnLiftedType,	-- Source types are always lifted
-  isUnboxedTupleType,	-- Ditto
+  isUnLiftedType,       -- Source types are always lifted
+  isUnboxedTupleType,   -- Ditto
   isPrimitiveType, 
 
   tyVarsOfType, tyVarsOfTypes, closeOverKinds,
@@ -187,24 +181,24 @@ import Control.Applicative (Applicative(..))
 \end{code}
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection{Types}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 The type checker divides the generic Type world into the 
 following more structured beasts:
 
 sigma ::= forall tyvars. phi
-	-- A sigma type is a qualified type
-	--
-	-- Note that even if 'tyvars' is empty, theta
-	-- may not be: e.g.   (?x::Int) => Int
+        -- A sigma type is a qualified type
+        --
+        -- Note that even if 'tyvars' is empty, theta
+        -- may not be: e.g.   (?x::Int) => Int
 
-	-- Note that 'sigma' is in prenex form:
-	-- all the foralls are at the front.
-	-- A 'phi' type has no foralls to the right of
-	-- an arrow
+        -- Note that 'sigma' is in prenex form:
+        -- all the foralls are at the front.
+        -- A 'phi' type has no foralls to the right of
+        -- an arrow
 
 phi :: theta => rho
 
@@ -222,13 +216,13 @@ tau ::= tyvar
 -- provided it expands to the required form.
 
 \begin{code}
-type TcTyVar = TyVar  	-- Used only during type inference
-type TcCoVar = CoVar  	-- Used only during type inference; mutable
-type TcType = Type 	-- A TcType can have mutable type variables
-	-- Invariant on ForAllTy in TcTypes:
-	-- 	forall a. T
-	-- a cannot occur inside a MutTyVar in T; that is,
-	-- T is "flattened" before quantifying over a
+type TcTyVar = TyVar    -- Used only during type inference
+type TcCoVar = CoVar    -- Used only during type inference; mutable
+type TcType = Type      -- A TcType can have mutable type variables
+        -- Invariant on ForAllTy in TcTypes:
+        --      forall a. T
+        -- a cannot occur inside a MutTyVar in T; that is,
+        -- T is "flattened" before quantifying over a
 
 -- These types do not have boxy type variables in them
 type TcPredType     = PredType
@@ -242,9 +236,9 @@ type TcTyVarSet     = TyVarSet
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection{TyVarDetails}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 TyVarDetails gives extra info about type variables, used during type
@@ -264,7 +258,7 @@ Consider this
 Here, x and y have type sigs, which go into the environment.  We used to
 instantiate their types with skolem constants, and push those types into
 the RHS, so we'd typecheck the RHS with type
-	( [a*], b*, c )
+        ( [a*], b*, c )
 where a*, b* are skolem constants, and c is an ordinary meta type varible.
 
 The trouble is that the occurrences of z in the RHS force a* and b* to 
@@ -294,7 +288,7 @@ data TcTyVarDetails
 
   | FlatSkol TcType
            -- The "skolem" obtained by flattening during
-    	   -- constraint simplification
+           -- constraint simplification
     
            -- In comments we will use the notation alpha[flat = ty]
            -- to represent a flattening skolem variable alpha
@@ -319,53 +313,53 @@ instance Outputable MetaDetails where
   ppr (Indirect ty) = ptext (sLit "Indirect") <+> ppr ty
 
 data MetaInfo
-   = TauTv	   -- This MetaTv is an ordinary unification variable
-     		   -- A TauTv is always filled in with a tau-type, which
-		   -- never contains any ForAlls 
+   = TauTv         -- This MetaTv is an ordinary unification variable
+                   -- A TauTv is always filled in with a tau-type, which
+                   -- never contains any ForAlls 
 
    | PolyTv        -- Like TauTv, but can unify with a sigma-type
 
-   | SigTv 	   -- A variant of TauTv, except that it should not be
-		   -- unified with a type, only with a type variable
-		   -- SigTvs are only distinguished to improve error messages
-		   --      see Note [Signature skolems]        
-		   --      The MetaDetails, if filled in, will 
-		   --      always be another SigTv or a SkolemTv
+   | SigTv         -- A variant of TauTv, except that it should not be
+                   -- unified with a type, only with a type variable
+                   -- SigTvs are only distinguished to improve error messages
+                   --      see Note [Signature skolems]        
+                   --      The MetaDetails, if filled in, will 
+                   --      always be another SigTv or a SkolemTv
 
 -------------------------------------
 -- UserTypeCtxt describes the origin of the polymorphic type
 -- in the places where we need to an expression has that type
 
 data UserTypeCtxt
-  = FunSigCtxt Name	-- Function type signature
-			-- Also used for types in SPECIALISE pragmas
-  | InfSigCtxt Name	-- Inferred type for function
-  | ExprSigCtxt		-- Expression type signature
-  | ConArgCtxt Name	-- Data constructor argument
-  | TySynCtxt Name	-- RHS of a type synonym decl
-  | LamPatSigCtxt		-- Type sig in lambda pattern
-			-- 	f (x::t) = ...
-  | BindPatSigCtxt	-- Type sig in pattern binding pattern
-			--	(x::t, y) = e
+  = FunSigCtxt Name     -- Function type signature
+                        -- Also used for types in SPECIALISE pragmas
+  | InfSigCtxt Name     -- Inferred type for function
+  | ExprSigCtxt         -- Expression type signature
+  | ConArgCtxt Name     -- Data constructor argument
+  | TySynCtxt Name      -- RHS of a type synonym decl
+  | LamPatSigCtxt               -- Type sig in lambda pattern
+                        --      f (x::t) = ...
+  | BindPatSigCtxt      -- Type sig in pattern binding pattern
+                        --      (x::t, y) = e
   | RuleSigCtxt Name    -- LHS of a RULE forall
                         --    RULE "foo" forall (x :: a -> a). f (Just x) = ...
-  | ResSigCtxt		-- Result type sig
-			-- 	f x :: t = ....
-  | ForSigCtxt Name	-- Foreign import or export signature
-  | DefaultDeclCtxt	-- Types in a default declaration
+  | ResSigCtxt          -- Result type sig
+                        --      f x :: t = ....
+  | ForSigCtxt Name     -- Foreign import or export signature
+  | DefaultDeclCtxt     -- Types in a default declaration
   | InstDeclCtxt        -- An instance declaration
-  | SpecInstCtxt	-- SPECIALISE instance pragma
-  | ThBrackCtxt		-- Template Haskell type brackets [t| ... |]
+  | SpecInstCtxt        -- SPECIALISE instance pragma
+  | ThBrackCtxt         -- Template Haskell type brackets [t| ... |]
   | GenSigCtxt          -- Higher-rank or impredicative situations
                         -- e.g. (f e) where f has a higher-rank type
                         -- We might want to elaborate this
   | GhciCtxt            -- GHCi command :kind <type>
 
-  | ClassSCCtxt Name	-- Superclasses of a class
-  | SigmaCtxt		-- Theta part of a normal for-all type
-			--	f :: <S> => a -> a
-  | DataTyCtxt Name	-- Theta part of a data decl
-			--	data <S> => T a = MkT a
+  | ClassSCCtxt Name    -- Superclasses of a class
+  | SigmaCtxt           -- Theta part of a normal for-all type
+                        --      f :: <S> => a -> a
+  | DataTyCtxt Name     -- Theta part of a data decl
+                        --      data <S> => T a = MkT a
 \end{code}
 
 
@@ -374,16 +368,16 @@ data UserTypeCtxt
 --
 -- If the RHS mentions tyvars that aren't in scope, we'll 
 -- quantify over them:
---	e.g. 	type T = a->a
--- will become	type T = forall a. a->a
+--      e.g.    type T = a->a
+-- will become  type T = forall a. a->a
 --
 -- With gla-exts that's right, but for H98 we should complain. 
 
 
 %************************************************************************
-%*									*
-		Untoucable type variables
-%*									*
+%*                                                                      *
+                Untoucable type variables
+%*                                                                      *
 %************************************************************************
 
 Note [Untouchable type variables]
@@ -467,9 +461,9 @@ instance Outputable Untouchables where
 
 
 %************************************************************************
-%*									*
-		Pretty-printing
-%*									*
+%*                                                                      *
+                Pretty-printing
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -586,9 +580,9 @@ exactTyVarsOfTypes tys = foldr (unionVarSet . exactTyVarsOfType) emptyVarSet tys
 \end{code}
 
 %************************************************************************
-%*									*
-		Predicates
-%*									*
+%*                                                                      *
+                Predicates
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -617,15 +611,15 @@ isImmutableTyVar tv
 isTyConableTyVar, isSkolemTyVar, isOverlappableTyVar,
   isMetaTyVar, isAmbiguousTyVar, isFlatSkolTyVar :: TcTyVar -> Bool 
 
-isTyConableTyVar tv	
-	-- True of a meta-type variable that can be filled in 
-	-- with a type constructor application; in particular,
-	-- not a SigTv
+isTyConableTyVar tv     
+        -- True of a meta-type variable that can be filled in 
+        -- with a type constructor application; in particular,
+        -- not a SigTv
   = ASSERT( isTcTyVar tv) 
     case tcTyVarDetails tv of
-	MetaTv { mtv_info = SigTv } -> False
-	_                           -> True
-	
+        MetaTv { mtv_info = SigTv } -> False
+        _                           -> True
+        
 isFlatSkolTyVar tv
   = ASSERT2( isTcTyVar tv, ppr tv )
     case tcTyVarDetails tv of
@@ -649,8 +643,8 @@ isOverlappableTyVar tv
 isMetaTyVar tv 
   = ASSERT2( isTcTyVar tv, ppr tv )
     case tcTyVarDetails tv of
-	MetaTv {} -> True
-	_         -> False
+        MetaTv {} -> True
+        _         -> False
 
 -- isAmbiguousTyVar is used only when reporting type errors
 -- It picks out variables that are unbound, namely meta
@@ -660,9 +654,9 @@ isMetaTyVar tv
 isAmbiguousTyVar tv 
   = ASSERT2( isTcTyVar tv, ppr tv )
     case tcTyVarDetails tv of
-	MetaTv {}     -> True
-	RuntimeUnk {} -> True
-	_             -> False
+        MetaTv {}     -> True
+        RuntimeUnk {} -> True
+        _             -> False
 
 isMetaTyVarTy :: TcType -> Bool
 isMetaTyVarTy (TyVarTy tv) = isMetaTyVar tv
@@ -693,15 +687,15 @@ isSigTyVar :: Var -> Bool
 isSigTyVar tv 
   = ASSERT( isTcTyVar tv )
     case tcTyVarDetails tv of
-	MetaTv { mtv_info = SigTv } -> True
-	_                           -> False
+        MetaTv { mtv_info = SigTv } -> True
+        _                           -> False
 
 metaTvRef :: TyVar -> IORef MetaDetails
 metaTvRef tv 
   = ASSERT2( isTcTyVar tv, ppr tv )
     case tcTyVarDetails tv of
-	MetaTv { mtv_ref = ref } -> ref
-	_ -> pprPanic "metaTvRef" (ppr tv)
+        MetaTv { mtv_ref = ref } -> ref
+        _ -> pprPanic "metaTvRef" (ppr tv)
 
 isFlexi, isIndirect :: MetaDetails -> Bool
 isFlexi Flexi = True
@@ -719,9 +713,9 @@ isRuntimeUnkSkol x
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection{Tau, sigma and rho}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -754,11 +748,11 @@ mkTcEqPred ty1 ty2
 \begin{code}
 isTauTy :: Type -> Bool
 isTauTy ty | Just ty' <- tcView ty = isTauTy ty'
-isTauTy (TyVarTy _)	  = True
+isTauTy (TyVarTy _)       = True
 isTauTy (LitTy {})        = True
 isTauTy (TyConApp tc tys) = all isTauTy tys && isTauTyCon tc
-isTauTy (AppTy a b)	  = isTauTy a && isTauTy b
-isTauTy (FunTy a b)	  = isTauTy a && isTauTy b
+isTauTy (AppTy a b)       = isTauTy a && isTauTy b
+isTauTy (FunTy a b)       = isTauTy a && isTauTy b
 isTauTy (ForAllTy {})     = False
 
 isTauTyCon :: TyCon -> Bool
@@ -769,7 +763,7 @@ isTauTyCon tc
 
 ---------------
 getDFunTyKey :: Type -> OccName -- Get some string from a type, to be used to
-				-- construct a dictionary function name
+                                -- construct a dictionary function name
 getDFunTyKey ty | Just ty' <- tcView ty = getDFunTyKey ty'
 getDFunTyKey (TyVarTy tv)    = getOccName tv
 getDFunTyKey (TyConApp tc _) = getOccName tc
@@ -785,13 +779,13 @@ getDFunTyLitKey (StrTyLit n) = mkOccName Name.varName (show n)  -- hm
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection{Expanding and splitting}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 These tcSplit functions are like their non-Tc analogues, but
-	*) they do not look through newtypes
+        *) they do not look through newtypes
 
 However, they are non-monadic and do not follow through mutable type
 variables.  It's up to you to make sure this doesn't matter.
@@ -824,13 +818,13 @@ tcSplitPhiTy ty
   where
     split ty ts 
       = case tcSplitPredFunTy_maybe ty of
-	  Just (pred, ty) -> split ty (pred:ts)
-	  Nothing         -> (reverse ts, ty)
+          Just (pred, ty) -> split ty (pred:ts)
+          Nothing         -> (reverse ts, ty)
 
 tcSplitSigmaTy :: Type -> ([TyVar], ThetaType, Type)
 tcSplitSigmaTy ty = case tcSplitForAllTys ty of
-			(tvs, rho) -> case tcSplitPhiTy rho of
-					(theta, tau) -> (tvs, theta, tau)
+                        (tvs, rho) -> case tcSplitPhiTy rho of
+                                        (theta, tau) -> (tvs, theta, tau)
 
 -----------------------
 tcDeepSplitSigmaTy_maybe
@@ -852,60 +846,60 @@ tcDeepSplitSigmaTy_maybe ty
 -----------------------
 tcTyConAppTyCon :: Type -> TyCon
 tcTyConAppTyCon ty = case tcSplitTyConApp_maybe ty of
-			Just (tc, _) -> tc
-			Nothing	     -> pprPanic "tcTyConAppTyCon" (pprType ty)
+                        Just (tc, _) -> tc
+                        Nothing      -> pprPanic "tcTyConAppTyCon" (pprType ty)
 
 tcTyConAppArgs :: Type -> [Type]
 tcTyConAppArgs ty = case tcSplitTyConApp_maybe ty of
-			Just (_, args) -> args
-			Nothing	       -> pprPanic "tcTyConAppArgs" (pprType ty)
+                        Just (_, args) -> args
+                        Nothing        -> pprPanic "tcTyConAppArgs" (pprType ty)
 
 tcSplitTyConApp :: Type -> (TyCon, [Type])
 tcSplitTyConApp ty = case tcSplitTyConApp_maybe ty of
-			Just stuff -> stuff
-			Nothing	   -> pprPanic "tcSplitTyConApp" (pprType ty)
+                        Just stuff -> stuff
+                        Nothing    -> pprPanic "tcSplitTyConApp" (pprType ty)
 
 tcSplitTyConApp_maybe :: Type -> Maybe (TyCon, [Type])
 tcSplitTyConApp_maybe ty | Just ty' <- tcView ty = tcSplitTyConApp_maybe ty'
 tcSplitTyConApp_maybe (TyConApp tc tys) = Just (tc, tys)
 tcSplitTyConApp_maybe (FunTy arg res)   = Just (funTyCon, [arg,res])
-	-- Newtypes are opaque, so they may be split
-	-- However, predicates are not treated
-	-- as tycon applications by the type checker
+        -- Newtypes are opaque, so they may be split
+        -- However, predicates are not treated
+        -- as tycon applications by the type checker
 tcSplitTyConApp_maybe _                 = Nothing
 
 -----------------------
 tcSplitFunTys :: Type -> ([Type], Type)
 tcSplitFunTys ty = case tcSplitFunTy_maybe ty of
-			Nothing	       -> ([], ty)
-			Just (arg,res) -> (arg:args, res')
-				       where
-					  (args,res') = tcSplitFunTys res
+                        Nothing        -> ([], ty)
+                        Just (arg,res) -> (arg:args, res')
+                                       where
+                                          (args,res') = tcSplitFunTys res
 
 tcSplitFunTy_maybe :: Type -> Maybe (Type, Type)
 tcSplitFunTy_maybe ty | Just ty' <- tcView ty           = tcSplitFunTy_maybe ty'
 tcSplitFunTy_maybe (FunTy arg res) | not (isPredTy arg) = Just (arg, res)
 tcSplitFunTy_maybe _                                    = Nothing
-	-- Note the typeKind guard
-	-- Consider	(?x::Int) => Bool
-	-- We don't want to treat this as a function type!
-	-- A concrete example is test tc230:
-	--	f :: () -> (?p :: ()) => () -> ()
-	--
-	--	g = f () ()
+        -- Note the typeKind guard
+        -- Consider     (?x::Int) => Bool
+        -- We don't want to treat this as a function type!
+        -- A concrete example is test tc230:
+        --      f :: () -> (?p :: ()) => () -> ()
+        --
+        --      g = f () ()
 
 tcSplitFunTysN
-	:: TcRhoType 
-	-> Arity		-- N: Number of desired args
-	-> ([TcSigmaType], 	-- Arg types (N or fewer)
-	    TcSigmaType)	-- The rest of the type
+        :: TcRhoType 
+        -> Arity                -- N: Number of desired args
+        -> ([TcSigmaType],      -- Arg types (N or fewer)
+            TcSigmaType)        -- The rest of the type
 
 tcSplitFunTysN ty n_args
   | n_args == 0
   = ([], ty)
   | Just (arg,res) <- tcSplitFunTy_maybe ty
   = case tcSplitFunTysN res (n_args - 1) of
-	(args, res) -> (arg:args, res)
+        (args, res) -> (arg:args, res)
   | otherwise
   = ([], ty)
 
@@ -925,16 +919,16 @@ tcSplitAppTy_maybe ty = repSplitAppTy_maybe ty
 
 tcSplitAppTy :: Type -> (Type, Type)
 tcSplitAppTy ty = case tcSplitAppTy_maybe ty of
-		    Just stuff -> stuff
-		    Nothing    -> pprPanic "tcSplitAppTy" (pprType ty)
+                    Just stuff -> stuff
+                    Nothing    -> pprPanic "tcSplitAppTy" (pprType ty)
 
 tcSplitAppTys :: Type -> (Type, [Type])
 tcSplitAppTys ty
   = go ty []
   where
     go ty args = case tcSplitAppTy_maybe ty of
-		   Just (ty', arg) -> go ty' (arg:args)
-		   Nothing	   -> (ty,args)
+                   Just (ty', arg) -> go ty' (arg:args)
+                   Nothing         -> (ty,args)
 
 -----------------------
 tcGetTyVar_maybe :: Type -> Maybe TyVar
@@ -985,17 +979,17 @@ tcInstHeadTyAppAllTyVars ty
   = tcInstHeadTyAppAllTyVars ty'
   | otherwise
   = case ty of
-	TyConApp _ tys  -> ok (filter (not . isKind) tys)  -- avoid kinds
-	FunTy arg res   -> ok [arg, res]
-	_               -> False
+        TyConApp _ tys  -> ok (filter (not . isKind) tys)  -- avoid kinds
+        FunTy arg res   -> ok [arg, res]
+        _               -> False
   where
-	-- Check that all the types are type variables,
-	-- and that each is distinct
+        -- Check that all the types are type variables,
+        -- and that each is distinct
     ok tys = equalLength tvs tys && hasNoDups tvs
-	   where
-	     tvs = mapCatMaybes get_tv tys
+           where
+             tvs = mapCatMaybes get_tv tys
 
-    get_tv (TyVarTy tv)  = Just tv	-- through synonyms
+    get_tv (TyVarTy tv)  = Just tv      -- through synonyms
     get_tv _             = Nothing
 \end{code}
 
@@ -1116,11 +1110,11 @@ occurCheckExpand dflags tv ty
                        | otherwise = return t
     go ty@(LitTy {}) = return ty
     go (AppTy ty1 ty2) = do { ty1' <- go ty1
-           		    ; ty2' <- go ty2  
-           		    ; return (mkAppTy ty1' ty2') }
+                            ; ty2' <- go ty2  
+                            ; return (mkAppTy ty1' ty2') }
     go (FunTy ty1 ty2) = do { ty1' <- go ty1 
-           		    ; ty2' <- go ty2 
-           		    ; return (mkFunTy ty1' ty2') } 
+                            ; ty2' <- go ty2 
+                            ; return (mkFunTy ty1' ty2') } 
     go ty@(ForAllTy tv' body_ty)
        | not impredicative                = OC_Forall
        | not (fast_check (tyVarKind tv')) = OC_Occurs
@@ -1146,9 +1140,9 @@ occurCheckExpand dflags tv ty
 \end{code}
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection{Predicate types}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 Deconstructors and tests on predicate types
@@ -1211,14 +1205,14 @@ immSuperClasses cls tys
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection{Predicates}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 isSigmaTy returns true of any qualified type.  It doesn't *necessarily* have 
 any foralls.  E.g.
-	f :: (?x::Int) => Int -> Int
+        f :: (?x::Int) => Int -> Int
 
 \begin{code}
 isSigmaTy :: Type -> Bool
@@ -1258,8 +1252,8 @@ isStringTy ty
 is_tc :: Unique -> Type -> Bool
 -- Newtypes are opaque to this
 is_tc uniq ty = case tcSplitTyConApp_maybe ty of
-			Just (tc, _) -> uniq == getUnique tc
-			Nothing	     -> False
+                        Just (tc, _) -> uniq == getUnique tc
+                        Nothing      -> False
 \end{code}
 
 \begin{code}
@@ -1274,9 +1268,9 @@ isSynFamilyTyConApp _other            = False
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection{Misc}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -1288,14 +1282,14 @@ deNoteType ty = ty
 tcTyVarsOfType :: Type -> TcTyVarSet
 -- Just the *TcTyVars* free in the type
 -- (Types.tyVarsOfTypes finds all free TyVars)
-tcTyVarsOfType (TyVarTy tv)	    = if isTcTyVar tv then unitVarSet tv
-						      else emptyVarSet
+tcTyVarsOfType (TyVarTy tv)         = if isTcTyVar tv then unitVarSet tv
+                                                      else emptyVarSet
 tcTyVarsOfType (TyConApp _ tys)     = tcTyVarsOfTypes tys
 tcTyVarsOfType (LitTy {})           = emptyVarSet
-tcTyVarsOfType (FunTy arg res)	    = tcTyVarsOfType arg `unionVarSet` tcTyVarsOfType res
-tcTyVarsOfType (AppTy fun arg)	    = tcTyVarsOfType fun `unionVarSet` tcTyVarsOfType arg
+tcTyVarsOfType (FunTy arg res)      = tcTyVarsOfType arg `unionVarSet` tcTyVarsOfType res
+tcTyVarsOfType (AppTy fun arg)      = tcTyVarsOfType fun `unionVarSet` tcTyVarsOfType arg
 tcTyVarsOfType (ForAllTy tyvar ty)  = tcTyVarsOfType ty `delVarSet` tyvar
-	-- We do sometimes quantify over skolem TcTyVars
+        -- We do sometimes quantify over skolem TcTyVars
 
 tcTyVarsOfTypes :: [Type] -> TyVarSet
 tcTyVarsOfTypes tys = foldr (unionVarSet.tcTyVarsOfType) emptyVarSet tys
@@ -1312,14 +1306,14 @@ orphNamesOfTyCon tycon = unitNameSet (getName tycon) `unionNameSets` case tyConC
 
 orphNamesOfType :: Type -> NameSet
 orphNamesOfType ty | Just ty' <- tcView ty = orphNamesOfType ty'
-		-- Look through type synonyms (Trac #4912)
-orphNamesOfType (TyVarTy _)		   = emptyNameSet
+                -- Look through type synonyms (Trac #4912)
+orphNamesOfType (TyVarTy _)                = emptyNameSet
 orphNamesOfType (TyConApp tycon tys)       = orphNamesOfTyCon tycon
                                              `unionNameSets` orphNamesOfTypes tys
 orphNamesOfType (LitTy {})          = emptyNameSet
-orphNamesOfType (FunTy arg res)	    = orphNamesOfType arg `unionNameSets` orphNamesOfType res
-orphNamesOfType (AppTy fun arg)	    = orphNamesOfType fun `unionNameSets` orphNamesOfType arg
-orphNamesOfType (ForAllTy _ ty)	    = orphNamesOfType ty
+orphNamesOfType (FunTy arg res)     = orphNamesOfType arg `unionNameSets` orphNamesOfType res
+orphNamesOfType (AppTy fun arg)     = orphNamesOfType fun `unionNameSets` orphNamesOfType arg
+orphNamesOfType (ForAllTy _ ty)     = orphNamesOfType ty
 
 orphNamesOfThings :: (a -> NameSet) -> [a] -> NameSet
 orphNamesOfThings f = foldr (unionNameSets . f) emptyNameSet
@@ -1331,12 +1325,12 @@ orphNamesOfDFunHead :: Type -> NameSet
 -- Find the free type constructors and classes 
 -- of the head of the dfun instance type
 -- The 'dfun_head_type' is because of
---	instance Foo a => Baz T where ...
+--      instance Foo a => Baz T where ...
 -- The decl is an orphan if Baz and T are both not locally defined,
---	even if Foo *is* locally defined
+--      even if Foo *is* locally defined
 orphNamesOfDFunHead dfun_ty 
   = case tcSplitSigmaTy dfun_ty of
-	(_, _, head_ty) -> orphNamesOfType head_ty
+        (_, _, head_ty) -> orphNamesOfType head_ty
         
 orphNamesOfCo :: Coercion -> NameSet
 orphNamesOfCo (Refl _ ty)           = orphNamesOfType ty
@@ -1372,9 +1366,9 @@ orphNamesOfCoAxBranch (CoAxBranch { cab_lhs = lhs, cab_rhs = rhs })
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection[TysWiredIn-ext-type]{External types}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 The compiler's foreign function interface supports the passing of a
@@ -1451,10 +1445,10 @@ isFFIPrimResultTy dflags ty
 isFFIDotnetTy :: DynFlags -> Type -> Bool
 isFFIDotnetTy dflags ty
   = checkRepTyCon (\ tc -> (legalFIResultTyCon dflags tc || 
-			   isFFIDotnetObjTy ty || isStringTy ty)) ty
-	-- NB: isStringTy used to look through newtypes, but
-	--     it no longer does so.  May need to adjust isFFIDotNetTy
-	--     if we do want to look through newtypes.
+                           isFFIDotnetObjTy ty || isStringTy ty)) ty
+        -- NB: isStringTy used to look through newtypes, but
+        --     it no longer does so.  May need to adjust isFFIDotNetTy
+        --     if we do want to look through newtypes.
 
 isFFIDotnetObjTy :: Type -> Bool
 isFFIDotnetObjTy ty
@@ -1511,7 +1505,7 @@ legalFEArgTyCon tc
 legalFIResultTyCon :: DynFlags -> TyCon -> Bool
 legalFIResultTyCon dflags tc
   | tc == unitTyCon         = True
-  | otherwise	            = marshalableTyCon dflags tc
+  | otherwise               = marshalableTyCon dflags tc
 
 legalFEResultTyCon :: TyCon -> Bool
 legalFEResultTyCon tc
@@ -1533,23 +1527,23 @@ marshalableTyCon dflags tc
   =  (xopt Opt_UnliftedFFITypes dflags 
       && isUnLiftedTyCon tc
       && not (isUnboxedTupleTyCon tc)
-      && case tyConPrimRep tc of	-- Note [Marshalling VoidRep]
-	   VoidRep -> False
-	   _       -> True)
+      && case tyConPrimRep tc of        -- Note [Marshalling VoidRep]
+           VoidRep -> False
+           _       -> True)
   || boxedMarshalableTyCon tc
 
 boxedMarshalableTyCon :: TyCon -> Bool
 boxedMarshalableTyCon tc
    = getUnique tc `elem` [ intTyConKey, int8TyConKey, int16TyConKey
-			 , int32TyConKey, int64TyConKey
-			 , wordTyConKey, word8TyConKey, word16TyConKey
-			 , word32TyConKey, word64TyConKey
-			 , floatTyConKey, doubleTyConKey
-			 , ptrTyConKey, funPtrTyConKey
-			 , charTyConKey
-			 , stablePtrTyConKey
-			 , boolTyConKey
-			 ]
+                         , int32TyConKey, int64TyConKey
+                         , wordTyConKey, word8TyConKey, word16TyConKey
+                         , word32TyConKey, word64TyConKey
+                         , floatTyConKey, doubleTyConKey
+                         , ptrTyConKey, funPtrTyConKey
+                         , charTyConKey
+                         , stablePtrTyConKey
+                         , boolTyConKey
+                         ]
 
 legalFIPrimArgTyCon :: DynFlags -> TyCon -> Bool
 -- Check args of 'foreign import prim', only allow simple unlifted types.
@@ -1567,16 +1561,16 @@ legalFIPrimResultTyCon dflags tc
   = xopt Opt_UnliftedFFITypes dflags
     && isUnLiftedTyCon tc
     && (isUnboxedTupleTyCon tc
-        || case tyConPrimRep tc of	-- Note [Marshalling VoidRep]
-	   VoidRep -> False
-	   _       -> True)
+        || case tyConPrimRep tc of      -- Note [Marshalling VoidRep]
+           VoidRep -> False
+           _       -> True)
 \end{code}
 
 Note [Marshalling VoidRep]
 ~~~~~~~~~~~~~~~~~~~~~~~~~~
 We don't treat State# (whose PrimRep is VoidRep) as marshalable.
 In turn that means you can't write
-	foreign import foo :: Int -> State# RealWorld
+        foreign import foo :: Int -> State# RealWorld
 
 Reason: the back end falls over with panic "primRepHint:VoidRep";
-	and there is no compelling reason to permit it
+        and there is no compelling reason to permit it
